/* Definitions for the JPEGD driver */

#if  !defined( __JPEGD__ )
#define __JPEGD__

typedef struct __jpdPB{
   void *comp_data;
   void *decomp_data;      /* when no dithering is done */
   long comp_size;
   long decomp_size;
   int dummy1;
   int magic12;            /* 3 for 24/16 bits/pixel */
   int magic14;            /* 3 for 24, 2 for 16 bits/pixel */
   int ditherflag;         /* when -1 dither() is executed, when 0 not */
   int dummy2;
   int zones;              /* the number of times, timer() will be called */
   int (*dummyfun1)(void); /* return 0; */
   int (*dither)(struct __jpdPB *);   /* look ditherflag */
   int (*dummyfun2)(void);    /* return 0; */
   int (*dummyfun3)(void);   /*   was void  (return;) */
   int dummy3[8];
   int (*timer)(struct __jpdPB *);  /* called during decoding */
   unsigned char *outbuffer;  /* Filled when 'dithering'  ($40) */
   int dummy4[2];
   void *decomp_data1;        /* used by dither() */
   long planes;
   int dummy5[3];
   int image_w;
   int image_h;
} JPDPB;

typedef struct {
   long magic;	/* 1L */
   int (*JPD_open)(JPDPB *);
   int (*JPD_close)(void);
   long (*JPD_getPBsize)(void);
   int (*JPD_getJPGinfo)(JPDPB *);
   int (*JPD_calcpixels)(JPDPB *);
   int (*JPD_decode)(JPDPB *);
} JPD_functab;

#endif
