#include "jpegd.h"
#include <tos.h>
#include <string.h>
#include <stdlib.h>

#define NULL 0L

typedef struct { long cookie; long value;}COOKIE;

int getcookie(long target, long *value);
int mytimer(JPDPB *);
unsigned long gethz200(void);
int main(int argc, const char *argv[]);


int magicwords[5] = {-1, -1, -1, -1, 0};
long ssp;
int counter;


int main(int argc, const char *argv[]){
	JPD_functab *functab;
	JPDPB *mypb;
	const char *fname = argv[1];
	int handle;
	long length, pbsize, tempw, temph;
	unsigned char *start;
	unsigned long time;

	
	if(!getcookie('_JPD',(long *)&functab)){
		Cconws("JPEGD driver not found\n\r");
		return -1;
	}
	
	if(fname == NULL){
		Cconws("No parameter passed\n\r");
		return -1;
	}

	handle = (int)Fopen(fname, FO_READ);
	if(handle < 0){
		Cconws("Cannot open file\n\r");
		return -1;
	}

	length = Fseek(0L, handle, 2);
	
	Fseek(0L, handle, 0);
	
	start = Malloc(length);
	if(start == NULL){
		Fclose(handle);
		Cconws("Cannot allocate memory\n\r");
		return -1;
	}

	
	if(length != Fread(handle, length, start)){
		Fclose(handle);
		Mfree(start);
		Cconws("Cannot read file\n\r");
		return -1;
	}
	
	Fclose(handle);

/* step 1 allocate the parameter block */
	
	mypb = Malloc( pbsize = functab->JPD_getPBsize() );
	
	memset(mypb, 0, pbsize);

/* step 2 open our "JPD station" */

	functab->JPD_open(mypb);
	
	mypb->comp_data = start;
	mypb->comp_size = length;
	functab->JPD_getJPGinfo(mypb);
	
	mypb->magic12 = 3;
	mypb->magic14 = 2;
	mypb->ditherflag = 0;
	functab->JPD_calcpixels(mypb);
	
	mypb->timer = mytimer;
	tempw = mypb->image_w + 15;
	tempw &= ~15;
	temph = mypb->image_h + 7;
	temph &= ~7;
	mypb->decomp_data = Malloc(tempw*temph*2); /* 2 represents bytes/pixel */
/*	time = Supexec((long)gethz200); */
	functab->JPD_decode(mypb);
/*	time = Supexec((long)gethz200) - time; */
	
	functab->JPD_close();

	Cconws("\n\r");	
/*	Cconws(ltoa(time/2, "     ", 10)); */
	Cconws("\n\r");
	
	Cnecin();
	return 0;
}

int mytimer(JPDPB *copyPB){
	char s[4];
	
	counter++;
	Cconws("Image decoding ");
	Cconws(itoa( (100*counter)/copyPB->zones, s, 10));
	Cconws(" %\r");
	return 0;
}

int getcookie(long target, long *value){
	long ssp; COOKIE *cookie_ptr;
	
	if(Super((void *)1L) == 0L)
		ssp = Super((void *)0L);
	else
		ssp = 0L;
	
	cookie_ptr = *(COOKIE **)0x5A0;
	
	if(ssp)
		Super((void *)ssp);
	
	if(cookie_ptr != NULL){
		do{
			if(cookie_ptr->cookie == target){
				if(value != NULL)
					*value = cookie_ptr->value;
				return 1;
			}
		}while((cookie_ptr++)->cookie != 0L);
	}
	return 0;
}

unsigned long gethz200(void){
	return *(unsigned long *)0x4baL;
}