	; PURE ASSEMBLER
	
	MC68030
	SUPER
	
	XDEF	hs_asm	
	XDEF	half_size_calculate, half_size
	XDEF	evaluate_script
	XDEF	clear_memory
	XDEF	modify_videl
	XDEF	init_mouse, restore_mouse, set_mouse, get_mouse
	XDEF	get_videl_info
	XDEF	print, x_tab, y_tab
	XDEF	mtext, ttext, shell_pal, header
	
xres	equ	80*8
yres	equ	6*8
	
	INCLUDE	"e:\src\falcon\equ\hw_reg.equ"
	
	
	TEXT
; in:
; a0 pekare till en PICTURE struct
; d0 en rads lngd i bytes	
	
hs_asm:	movem.l	d3/a2-a6,-(sp)
	move.l	(a0)+,a1		; Rad 1
	lea	(a1,d0.l),a2	; Rad 2
	move.w	(a0)+,d1		; dx
	subq.w	#1,d1
	move.w	(a0)+,d3		; dy
	subq.w	#1,d3
	move.l	a1,a0		; Destination
	movea.w	#RXM,a5
	movea.w	#ISR,a6
	
.wait:	btst.b	#0,(a6)		; Test RXDF (sync. with DSP)
	beq.s	.wait
	cmp.w	#$4242,(a5)
	bne.s	.wait
	
.l00:	move.w	d1,d2
	move.l	a1,a3
	move.l	a2,a4
	
.l01:	;btst.b	#1,(a6)
	;beq.s	*-4
	move.w	(a3)+,(a5)		; Skicka 4 bildpunkter
	
	;btst.b	#1,(a6)
	;beq.s	*-4
	move.w	(a3)+,(a5)
	
	;btst.b	#1,(a6)
	;beq.s	*-4
	move.w	(a4)+,(a5)
	
	;btst.b	#1,(a6)
	;beq.s	*-4
	move.w	(a4)+,(a5)
 	
 	btst.b	#0,(a6)
	beq.s	*-4
 	move.w	(a5),(a0)+		; Ta emot 1 bildpunkt
	
	dbra	d2,.l01
	lea	(a1,d0.l*2),a1
	lea	(a2,d0.l*2),a2
	dbra	d3,.l00
	movem.l	(sp)+,d3/a2-a6
	rts
	
; in:	
; a0 Pointer to a PICTURE struct
	
half_size_calculate:
	move.w	4(a0),d0		; dx
	move.w	d0,d1
	add.w	8(a0),d1		; dx+offset=half scanline in bytes
	lsl.w	d1
	move.w	d1,one_scanline
	clr.w	8(a0)		; New offset=0
	
	lsr.w	d0
	bclr.l	#0,d0
	move.w	d0,4(a0)		; Store new dx
	
	move.w	6(a0),d0
	lsr.w	d0
	bclr.l	#0,d0
	move.w	d0,6(a0)		; Store new dy
	rts
		
; in:	
; a0 Pointer to a PICTURE struct
	
half_size:	movem.l	d0-a6,-(sp)
	move.w	one_scanline,d2
	ext.l	d2		; One scanline in bytes
	move.l	d2,d0
	add.l	d0,d0		; Two scanlines in bytes
	
	move.w	4(a0),d1		; dx
	move.w	6(a0),d3		; dy
	move.l	(a0),a0		; Pointer to scanline n+0
	move.l	a0,a1
	add.l	d2,a1		; Pointer to scanline n+1
	move.l	a0,a4		; Pointer to destination
	subq.w	#1,d1		; Counter x
	move.w	d1,counter_x
	subq.w	#1,d3		; Counter y
	
.j2:	move.w	counter_x,d2	; Restore the x counter
	move.l	a0,a2
	move.l	a1,a3	
	
.j1:	move.l	(a2)+,d4
	move.l	(a3)+,d5
	
	move.l	#%00111110000000000011111000000000,d7
	move.l	d4,d6
	lsr.l	#2,d6
	and.l	d7,d6
	move.l	d5,d1
	lsr.l	#2,d1
	and.l	d7,d1
	add.l	d1,d6
	move.l	d6,d1
	swap	d1
	add.w	d1,d6
	and.w	#%1111100000000000,d6
	and.w	#%0000011111111111,d4
	or.w	d6,d4
	
	move.l	#%00000111111000000000011111100000,d7
	move.l	d4,d6
	and.l	d7,d6
	move.l	d5,d1
	and.l	d7,d1
	add.l	d1,d6
	move.l	d6,d1
	swap	d1
	add.w	d1,d6
	lsr.w	#2,d6
	and.w	d7,d6
	and.w	#%1111100000011111,d4
	or.w	d6,d4
	
	move.l	#%00000000000111110000000000011111,d7
	move.l	d4,d6
	and.l	d7,d6
	move.l	d5,d1
	and.l	d7,d1
	add.l	d1,d6
	move.l	d6,d1
	swap	d1
	add.w	d1,d6
	lsr.w	#2,d6
	and.w	d7,d6
	and.w	#%1111111111100000,d4
	or.w	d6,d4
	
	move.w	d4,(a4)+		; Store new colour
	dbra	d2,.j1
	add.l	d0,a0
	add.l	d0,a1
	dbra	d3,.j2
	movem.l	(sp)+,d0-a6
	rts
	
	DATA
	EVEN
one_scanline:	ds.w	1
counter_x:		ds.w	1
	TEXT
	
	
	
; in:	
; a0 pointer to a textfile
; a1 pointer to a SCRIPT struct
	
evaluate_script:
	moveq	#2,d0
.j3:	move.l	a0,(a1)+	; Pointer to ...
.j1:	cmp.b	#10,(a0)+	; LF
	bne.s	.j1	
	clr.b	-1(a0)
	cmp.b	#13,(a0)	; CR
	bne.s	.j2
	clr.b	(a0)+
.j2:	dbra	d0,.j3
	rts
	
	
	
; in:	
; d0 antal bytes
; a0 start adress
	
clear_memory:
	bfextu	d0{26:6},d1		; Rest
	lsr.l	#6,d0		; Antal 16 l
	clr.l	d2
	
.l00:	REPT	16
	move.l	d2,(a0)+
	ENDM
	subq.l	#1,d0
	bgt.s	.l00
	
	subq.l	#1,d1		; Frbered fr dbra
	bmi.s	.l02
.l01:	move.b	d2,(a0)+
	dbra	d1,.l01
.l02:	rts
	
	
	
; in:	
; a0 pointer to a PICTURE struct
; a1 pointer to VIDEL data
; d0 pointer to a VIDEL_INFO struct 
	
modify_videl:	
	movem.l	d0-a6,-(sp)
	move.l	d0,a2
	
	move.w	6(a1),d0		; VWRAP
	move.w	4(a0),d1		; Line width picture
	sub.w	d0,d1
	bpl.s	.j1
	
	neg.w	d1		; Split difference (is even)
	lsr.w	d1
	
	move.w	4(a0),6(a1)		; VWRAP = picture width
	
	move.w	18(a1),d2		; HDE
	sub.w	d1,d2
	bpl.s	.j4
	sub.w	d2,16(a1)		; Modify HDB
	clr.l	d2
.j4:	move.w	d2,18(a1)		; Save HDE
	add.w	d1,16(a1)		; Modify HDB
	
	move.w	8(a0),4(a1)		; OFFSET = offset from PICTURE struct
	bra.s	.j2
	
.j1:	add.w	8(a0),d1		; offset from PICTURE struct
	move.w	d1,4(a1)		; Change OFFSET
	
.j2:	move.w	2(a2),d0		; dy (videl heigth in lines/ pixels)
	sub.w	6(a0),d0		; dy - picture heigth
	ble.s	.j5
	tst.w	5(a2)		; Normal?
	bne.s	.j6
	lsl.w	#1,d0	
.j6:	tst.b	5(a2)		; Line doubling?
	beq.s	.j7
	lsl.w	#2,d0	
	
.j7:	lsr.w	d0		; Split difference (must be even in interlace)
	move.w	d0,d1
	btst.l	#0,d0
	beq.s	.j8
	addq.w	#1,d0		; Make values even
	subq.w	#1,d1
.j8:	add.w	d0,32(a1)		; Modify VDB
	sub.w	d1,34(a1)		; Modify VDE
.j5:	movem.l	(sp)+,d0-a6	
	rts
	
	
		
init_mouse:	move.l	a2,-(sp)
	dc.w	$a00a		; Hide mouse cursor
	dc.w	$a000
	move.l	a0,line_adr
	move.w	-12(a0),old_dx
	move.w	-04(a0),old_dy
	move.l	-602(a0),old_mxy
	move.l	(sp)+,a2
	rts
	
restore_mouse:
	dc.w	$a009		; Draw mouse cursor
	move.l	line_adr,a0
	move.w	old_dx,-12(a0)
	move.w	old_dy,-4(a0)
	move.l	old_mxy,-602(a0)
	rts
		
; in:	
; d0 delta x (int)
; d1 delta y (int)
	
set_mouse:	move.w	d0,dx
	move.w	d1,dy
	move.l	line_adr,a0
	
	tst.w	d0
	beq.s	.j1
	move.w	d0,-12(a0)
.j1:	tst.w	d1
	beq.s	.j2
	move.w	d1,-4(a0)
.j2:	rts
	
; in:	
; a0 pointer to a MY_MOUSE struct
	
get_mouse:	move.l	line_adr,a1
	tst.w	dx		; X and Y
	bne.s	.j3
	clr.w	(a0)+
	bra.s	.j4
.j3:	move.w	-344(a1),(a0)+
.j4:	tst.w	dy
	bne.s	.j5
	clr.w	(a0)+
	bra.s	.j6
.j5:	move.w	-342(a1),(a0)+
	
.j6:	move.b	-348(a1),d0		; cur_ms_stat
	btst.l	#0,d0		; Left button
	sne	(a0)+
	btst.l	#1,d0		; Right button
	sne	(a0)+
	bclr.b	#6,-348(a1)		; Left button changed since last mouse interupt
	sne	(a0)+
	bclr.b	#7,-348(a1)		; Right button changed since last mouse interupt
	sne	(a0)	
	rts
		
	BSS
	ALIGN	4
line_adr:	DS.L	1
old_mxy:	DS.L	1
old_dx:	DS.W	1
old_dy:	DS.W	1
dx:	DS.W	1
dy:	DS.W	1
	TEXT
	
	
	
; in:	
; a0 Pointer to VIDEL_INFO struct
; a1 Pointer to videl data
	
get_videl_info:
	move.w	8(a1),d0		; spshift
	btst.l	#8,d0		; HiColour?
	sne	4(a0)
		
	move.w	40(a1),d0		; VCO
	btst.l	#0,d0		; Line doubling?
	sne	5(a0)
	
	btst.l	#1,d0		; Skip line?
	sne	6(a0)
	
	move.w	6(a1),(a0)		; Store vwrap
	move.w	34(a1),d0		; VDE
	sub.w	32(a1),d0		; VDE-VDB
	
	tst.b	5(a0)
	beq.s	.j1
	lsr.w	#2,d0		; Double line, one line is worth 4
	bra.s	.j2
	
.j1:	tst.b	6(a0)
	bne.s	.j2
	lsr.w	#1,d0		; Normal, one line is worth 2
	
.j2:	move.w	d0,2(a0)		; Store, dy
	rts
	
	
	
; In d0.w x koordinat
; In d1.w y koordinat
; In a0   adress till en nollavslutad strng
; In a1   skrm adress (4 bitplan)
	
print:	movem.l	d3/a2-a6,-(sp)
	move.b	d0,d2		; x
	clr.l	d3		; tecken
	lea	x_tab,a3
	lea	y_tab,a4
	lea	system_font,a5
	
.new_line:	cmp.w	#yres/8-1,d1	; Avsluta om y>yres-1
	bhi.s	.l00
		
.NeXT:	move.b	(a0)+,d3		; Nytt tecken i d3
	beq.s	.l00		; Avsluta om 0
	cmp.b	#10,d3		; Line Feed om 10
	bne.s	.l01
	addq.w	#1,d1		; ka y
	move.w	d0,d2		; Ny x koordinat
	bra.s	.new_line
	
.l01:	cmp.w	#xres/8-1,d2	; Nsta tecken om x>xres-1
	bhi.s	.NeXT
	
	move.l	a1,a2		; Skrm adressen i a2
	lea	(a5,d3.l*8),a6	; Tecknets adress
	add.l	(a3,d2.w*4),a2	; +offset x
	add.l	(a4,d1.w*4),a2	; +offset y
	
	move.b	(a6)+,(a2)		; Kopiera tecknet till skrmen
	move.b	(a6)+,xres/8*4*1(a2)
	move.b	(a6)+,xres/8*4*2(a2)
	move.b	(a6)+,xres/8*4*3(a2)
	move.b	(a6)+,xres/8*4*4(a2)
	move.b	(a6)+,xres/8*4*5(a2)
	move.b	(a6)+,xres/8*4*6(a2)
	move.b	(a6)+,xres/8*4*7(a2)
	
	addq.w	#1,d2		; ka x
	bra.s	.NeXT
.l00:	movem.l	(sp)+,d3/a2-a6
	rts
	
	DATA
	INCLUDE	"inc\sys_font.s"
	BSS
x_tab:	DS.L	xres/8
y_tab:	DS.L	yres/8
	
	
	
	DATA
	INCLUDE	"inc\mtext.s"
	INCLUDE	"inc\ttext.s"
	INCLUDE	"inc\halfsize.s"
shell_pal:	DC.L	$000000ff
	DC.L	$ffff00ff
header:	DC.B	'CPEG v0.8',10
	DC.B	'Coyote, Aug 27 1996',0
	
	
	
	END