	;**********************
	; HALFSIZE.ASM        *
	;                     *
	; Coyote, Aug 30 1996 *
	;**********************
	
	INCLUDE	"e:\src\inc\equates.asm"
	INCLUDE	"e:\src\inc\macros.asm"
	
	ORG	p:$0
	jmp	<start
	
	;**** PROGRAM START ****	
	ORG	P:$40
	
start	ori	#3,mr			; Disable IPL0, 1 and 2
	move	#0,omr			; Disable ROM
	movep	#1,x:<<PBC			; Turn on Host Port
	movep	x:<<HRX,x0			; Clear Host Port
	movep	#0,x:<<HCR			; Turn off XMT and RCV interrupts
	
	move	#>32768,y0			; Shift constant
	move	#-1,m0
	move	#<high_tab,r0
	move	m0,m1
	move	#low_tab,r1
	move	#HRX,r3
	move	#2,m4
	move	#shift_tab,r4
	move	#shift,r5
	
	move	#>$424242,x0		; Synchronise with the CPU
	host_xmt	x0
	
forever	jclr	#0,x:<<HSR,*		; Get 4 pixels ...
	move	x:(r3),a	y:(r5),y1
	
	and	y1,a	a1,x0
	mpy	x0,y0,a	a1,n1
	move	a1,n0
	move	x:(r1+n1),a
	move	x:(r0+n0),x0
	or	x0,a
	move	a,b
	
	DUP	3
	jclr	#0,x:<<HSR,*
	move	x:(r3),a
	
	and	y1,a	a1,x0
	mpy	x0,y0,a	a1,n1
	move	a1,n0
	move	x:(r1+n1),a
	move	x:(r0+n0),x0
	or	x0,a
	add	a,b
	ENDM
	
	move	l:(r4)+,x
	move	b1,y1			; 8R 8G 8B in y1
	
	mpy	x1,y1,b			; Convert to 5R 6G 8B
	and	x0,b	l:(r4)+,x
	mpy	x1,y1,a
	and	x0,a	b1,x0
	or	x0,a	l:(r4)+,x
	mpy	x1,y1,b
	and	x0,b	a1,x0
	or	x0,b
	
	jclr	#1,x:<<HSR,*		; Send 1 pixel
	move	b1,x:(r3)
	
	jmp	<forever
	
	
	
	;**** DATA ****	
	ORG	X:$0
	
high_tab	
red	SET	0
	DUP	32
green	SET	0
	DUP	8
	DC	red+green
green	SET	green+2048
	ENDM
red	SET	red+65536
	ENDM
	
low_tab	
green	SET	0
	DUP	8
blue	SET	0
	DUP	32
	DC	green+blue
blue	SET	blue+1
	ENDM
green	SET	green+256
	ENDM
	
	ORG	Y:$0
	
shift	DC	$0000FF
	
	ORG	X:$400
shift_tab	DC	65536,262144,2097152
	ORG	Y:$400
mask_tab	DC	%000000001111100000000000
	DC	%000000000000011111100000
	DC	%000000000000000000011111
	
	
	
	END
